<?php

/*

 $Id: create_host.php,v 1.36 2003/07/21 03:33:06 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/create_host.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.   

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Create Host 
	The create-a-host wizard mojo ... we put the form here so the user
	can get immediate feedback on the things that are possibly wrong
	with the form.
*/

/* Start House Cleaning */
	require "../modules/config.php";

	// do anything that needs to be done here
	check_session();

	// setup the user environment
	setup_user_environment($action, $zone_id);
/* End House Cleaning */


// do whatever you have to to update the host
//   the $conf['error'] object gets updated automatically
if ( $not_first_visit ) {

	// create needed objects
	$host = new Host(0);
	$domain = new Domain($domain_id);
	$range = new Range($range_id);

        //force lowercase on the hardware address
        $ha =  $conf['ui']->clean_hardware_address($ha);

	$host->check_hostname($name, $domain);

        if (!$conf['zone']->has_domain_access($domain_id) AND !$user->is_admin) {
                $conf['error']->add_error('domain',$conf['zone']->name . " does not have access to $domain->name");
        }

	if ( $ha != '000000000000' ) {
		$host->check_hardware_address($ha,0,$range_id);
	}

	if (!$domain->name) { 
		$conf['error']->add_error('domain',"Please Specify a Domain");
	}

	// if its dynamic or they are specifing a IP we shouldn't do this test
	if ( $range->type != 'dynamic' && ! $specified_ip) {
		$host->check_ip_range($range_id);
	}
	
	//if they have specified a ip then we need to do a bunch of checking
	if ($specified_ip) { 

		// Create needed objects
		$ip_obj = new Ip(0);

		//First check to make sure it's really an IP
		if (!$ip_obj->is_dotted_quad($specified_ip)) {
                        $conf['error']->add_error('specified_ip', 'Invalid IP Address Entered');
		}

		$ip_int = $ip_obj->ip2int($specified_ip);

		//Now let's make sure it isn't in use.
		$sql = "SELECT host.id FROM host WHERE ip='$ip_int'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		//make sure we didn't find anything
		if ($results->id) { 
			$conf['error']->add_error('specified_ip',"Error this address is already in use");
		}

		//now check to make sure it isn't in a dynamic range
		$sql = "SELECT id FROM ranges WHERE start<='$ip_int' AND end>='$ip_int'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$results = mysql_fetch_object($db_results);

		$test_range = new Range($results->id);

		if ($test_range->type == "dynamic" or $test_range->type == "ddns") { 
			$conf['error']->add_error('specified_ip',"You can not add a specific ip in a dynamic range");
		} //test for dynamic range

		if (!$test_range->has_zone($conf['zone']->id)) {
			$conf['error']->add_error('specified_ip',"The Specified IP is not in the current zone");
		} 
		
		$found = false;
		
		//for use if we havn't found errors set $ip->id to the good stuff
		$ip = new Ip($ip_int);

	} //use_specified_ip

	
	// looks good ... create the host
	if ( ! $conf['error']->error_state AND $user->has_access($conf['zone']->id)) {

		if ( $range->type == 'dynamic' && !$specified_ip) {
			$ip->ip_int = 0;
			$dynamic_range = $range->id;
		}
		elseif (!$specified_ip) {
			$ip = $range->get_free_ip_address();
		}

		// If expire is set we need to turn it into a date time stamp
		if ($expire) { 
			$new_expire = time() + (86400 * $expire); 
			$expire = $new_expire;

		} 

		$host_id = $conf['zone']->create_host($name, $domain_id, $ip->ip_int, $dynamic_range, $ha, $os, $type, $location, $serial, $other_id, $range_id, $range->default_workgroup,$user->username,$purchase_date,$po_number,$warranty_date,$owning_unit,$user_id,$expire);
		
		$host = new Host($host_id);

		// woohoo!!! lets send them to the confirmation page
		$action = "confirmation";
	}
}

show_template('header');

if ($action == "confirmation") {
	$conf['ui']->display_confirmation("Host $host->name created <a href=\"" . $conf['web_path'] . "/create_host.php\" >[Create Another Host]</a>", "The host $host->name has been created in " . $host->zone->name, $conf['web_path'] . "/host.php?action=show_host&amp;host_id=$host_id");
} // confirmation

else {
	require ($conf['prefix'] . "/templates/show_create_host.inc");
} // else
?>

<? show_template('footer'); ?>

