<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: domain.php,v 1.6 2003/06/27 20:50:08 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/modules/domain.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Domain Module Document
	Domain Module handles Domain migration 
*/

/* Start House Keeping */
	
require "../../modules/config.php";

	// do anything that needs to be done here
	check_session();

	// setup the user environment
	setup_user_environment($action, $zone_id);

/* End House Keeping */

// Setup any vars we are going to need
$info = $conf['modules']->get_info("domain");

show_template('header'); 

/********************
    Work IF Block 
********************/

/*!
	@function add_domain_equiv
	@discussion if adding a equiv domain Old Domain name --> new domain name, configured in the module
		creates bob.cla.oregonstate.edu from bob.cla.orst.edu.... doesn't move hosts...
*/
if ($action == "add_domain_equiv") {

	/* Check to make sure there isn't a .oregonstate.edu already */
	$domain = new Domain($domain_id);
	$split_domain = split_domain($domain->name,$info['level']);
	$new_domain = $split_domain . "." . $info['dest'];
	$sql = "SELECT * FROM domain WHERE name='$new_domain'";
	$db_results = mysql_query($sql, $conf['dbh']);

	if ($r = mysql_fetch_object($db_results)) {
		$conf['error']->add_error('domain',"The Specified domain already has a " . $info['dest'] . " equivelent");
	}

	/* No Errors run with it! */
	if (!$conf['error']->error_state and $user->has_access($conf['zone']->id)) {
		$domain_id = $domain->new_domain($new_domain);
		$conf['zone']->insert_domain_zone($domain_id);

		/* Were done shoot them the confirmation */
		$conf['ui']->display_confirmation("Domain Creation Done", "$new_domain has been created, and is ready for your use",$conf['web_path'] . "/index.php");
	} 

	/* Errors our mojo we've lost it! */
	else {

		$action = "show_domain_add";

	}

} // add_domain_equiv

/*!
	@function migrate_zone
	@discussion Migrates an entire zone to the new domain, example take zone.cla and move all cla.orst.edu to cla.oregonstate.edu
		    Creates cnames for any needed hosts...
	@param $zone_id	ID of Zone to migrate
	@param $hosts	Array of hosts that get cnames... from cla.orst.edu --> cla.oregonstate.edu
	@param $mxs	Array of MX records that get cnames...
	@param $cnames  Array of CNAME records that get cnames...
*/
if ($action == "migrate_zone" AND ( $user->is_admin OR $user->is_zone_admin ) ) {

	// if they are creating cnames...
	if ($create_cnames) { 

		// Create the needed objects
		$cname = new Cname(0);

		// if cname --> host
		if ($hosts) { 

			foreach ($hosts as $host) {

				$host = new Host($host);

				$new_fqd = $host->name . "." . $info['dest'];
				$cname->check_name($host->name,$host->domain);
				$cname->check_server($new_fqd);

				if (!$conf['error']->error_state OR ( count($conf['error']->status) == 1 AND preg_match("/is\salready\sin\suse\sby\sa\sHost/",$conf['error']->get_message('name')) ) ) {
					$cname->new_item($new_fqd,$host->name,$host->domain->id,$conf['zone']->id);
				}

				else { 
					echo "<p class=\"fatalerror\">Unable to Create CNAME of Host ( $new_fqd ) stopping</p>";
					$conf['error']->show_all_errors();
					show_template('footer'); 
					exit(); 
				}

			} // end foreach

		} // hosts

		// if cname --> mx
		if ($mxs) {

			foreach ($mxs as $mx) {

				$mx = new MX($mx);
		
				$new_fqd = $mx->name . "." . $info['dest'];
				$cname->check_name($mx->name,$mx->domain);
				$cname->check_server($new_fqd);

				if (!$conf['error']->error_state OR ( count($conf['error']->status) == 1 AND preg_match("/is already in use by a MX/",$conf['error']->get_message('name')) ) ) { 
					$cname->new_item($new_fqd,$mx->name,$mx->domain->id,$conf['zone']->id);
				}

				else { 	
					echo "<p class=\"fatalerror\">Unable to Create CNAME of MX ( $new_fqd ) stopping</p>";
					$conf['error']->show_all_errors();
					show_template('footer');
					exit();
				}
			} // end foreach 

		} // mxs
		
		$conf['error']->error_state = false;

	} // create_cnames
	
	// Now let's get down to the dirty work!
	$domain = new Domain($domain_id);
	$split_domain = split_domain($domain->name,$info['level']);
	$new_domain = $split_domain . "." . $info['dest'];

	$new_domain_id = $conf['zone']->insert_domain($new_domain);	
	$conf['zone']->insert_domain_zone($new_domain_id);

	$new_domain = new Domain($new_domain_id);

	// Get all hosts in $domain_id and in $conf['zone']
	$sql = "SELECT id FROM host WHERE domain='$domain_id' AND zone='" . $conf['zone']->id . "'";
	$hosts = $conf['ui']->get_hosts($sql);

	// Get all MX records in $domain_id and in $conf['zone']
	$sql = "SELECT id FROM zone_mx WHERE domain='$domain_id' AND zone='" . $conf['zone']->id . "'";
	$mxs = $conf['ui']->get_mxs($sql);


	// Recurse through hosts
	foreach ($hosts as $host) {

		$host->check_hostname($host->name,$new_domain,$host->id);

		if (!$conf['error']->error_state) {
			$host->update_domain($new_domain_id);
		}

		else { 
			echo "<p class=\"fatalerror\">Unable to migrate $host->hostname stopping</p>";
			$conf['error']->show_all_errors();
			show_template('footer');
			exit();
		}

	} // end foreach hosts

	// Recurse through mxs
	foreach ($mxs as $mx) {
		
		$mx->check_name($mx->name,$new_domain,$mx->priority);

		if (!$conf['error']->error_state) {
			$mx->update_domain($new_domain_id);
		}

		else {
			echo "<p class=\"fatalerror\">Unable to migrate $mx->hostname stopping</p>";
			$conf['error']->show_all_errors();
			show_template('footer');
			exit();
		}

	} // end foreach mxs

	$conf['ui']->display_confirmation("Migration Compleate","You have sucessfully migrated your zone", $conf['web_path'] . "/index.php");

} // migrate_zone


/*****************
 Display If Block 
******************/

/*!
	@function show_domain_add
	@discussion displays the domain addition template
*/
if ($action == "show_domain_add") {

	require ($conf['prefix'] . "/templates/show_domain_add.inc");

} // show_domain_add

/*!
	@function show_migrate_zone
	@discussion Displays the very first page of the migration for an entire zone, this 
		    is basicly an explanation of what it means, and a RED warning of how this
		    can really mess your stuff up.
*/
elseif ( $action == "show_migrate_zone" AND ( $user->is_admin OR $user->is_zone_admin ) ) {

	require ($conf['prefix'] . "/templates/show_migrate_zone.inc");

} // show_migrate_zone

/*!
	@function create_cnames
	@discussion If they choose to we need to display a list of all hosts and let them create cnames
		    for them. This also includes the confirmation messages, if they choose this path ther
		    isn't a 3rd menu before it does all of the work... it goes strait from here to the work
*/
elseif ( $action == "confirm_migrate_zone" AND $create_cnames AND ( $user->is_admin OR $user->is_zone_admin ) ) {

	// Get any Host records in this zone with the set domain
	$sql = "SELECT id FROM host WHERE domain='$domain_id' AND zone='" . $conf['zone']->id . "'";
	$hosts = $conf['ui']->get_hosts($sql);

	// Get any MX records in this zone with the set domain
	$sql = "SELECT id FROM zone_mx WHERE domain='$domain_id' AND zone='" . $conf['zone']->id . "'";
	$mxs = $conf['ui']->get_mxs($sql);

	require ($conf['prefix'] . "/templates/show_migrate_zone_cnames.inc"); 

} // show_create_cname


/*!
	@function confirm_migrate_zone
	@discussion This confirms the fact that they want to actually migrate their zone, this is the last
		    warning they have, again we have some more RED text.
*/
elseif ( $action == "confirm_migrate_zone" AND ( $user->is_admin OR $user->is_zone_admin ) ) {

	$domain = new Domain($domain_id);

	$confirm_txt = "Are you sure you want to move all records under $domain->name to " . $info['dest'] . ". <p class=\"fatalerror\">This can cause some services,
			such as printing and e-mail, to not function properly.</p>";


	$conf['ui']->show_confirm( $conf['web_path'] . "/modules/domain.php?action=migrate_zone&amp;domain_id=$domain_id", $confirm_txt);

} // confirm_migrate_zone

?>
<? show_template('footer'); ?>

