<?php
/*

 $Id: vlan.php,v 1.7 2003/06/13 16:23:24 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/vlan.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
/*!
	@header Vlan Document
	Create/edit/delete VLAN's.

*/


/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);
/* End House Keeping */

// process any submits that may come our way
$title = "VLAN Information";

// first let's check the data for Create/Update
if ( $action == 'Create' || $action == 'Update' ) {
	// uh-oh, at least type something
	if ( ! $name && ! $vlan_id ) {
		$conf['error']->add_error('vlan_empty', "Please enter values for the form.");
		$conf['error']->error_state = true;
	}
	elseif ( (! is_int($vlan_id)) && ($vlan_id > 1024 ) ) {
		$conf['error']->add_error('vlan_id', "VLAN ID must be an integer from 1-1024.");
		$conf['error']->error_state = true;
	}
}

// now do things based on the form data
if ( $action == 'Create' ) {
	if ( $conf['error']->error_state ) {
		// there was an error so set the appropriate action
		$action = 'show_create';
		$vlan->name    = $name;
		$vlan->vlan_id = $vlan_id;
	}
	else {
		// check if the name already exists
		$sql = "SELECT * FROM vlan WHERE name='$name'";
		$db_result = mysql_query($sql, $conf['dbh']);

		// uh-oh ... we already have one like this
		if ( mysql_fetch_object($db_result) ) {
			// create an error and set the page back to create/update
			$conf['error']->add_error('vlan_duplicate', "A VLAN by that name already exists.");
			$conf['error']->error_state = true;
		}
		else {
			// insert into the database
			$sql = "INSERT INTO vlan (name,vlan_id) VALUES ('$name', '$vlan_id')";
			$db_result = mysql_query($sql, $conf['dbh']);
			$vlan = new VLAN( mysql_insert_id($conf['dbh']) );
		}

		$action = 'edit';
	}
}
elseif ( $action == 'Update' ) {
	// errors fall through to the form (because they should)
	// check if the name already exists
	$sql = "SELECT * FROM vlan WHERE name='$name' AND vlan_id='$vlan_id'";
	$db_result = mysql_query($sql, $conf['dbh']);

	// uh-oh ... we already have one like this
	if ( mysql_fetch_object($db_result) ) {
		// create an error and set the page back to create/update
		$conf['error']->add_error('vlan_duplicate', "A VLAN by that name already exists.");
		$conf['error']->error_state = true;
	}
	else {
		$sql = "UPDATE vlan set name='$name', vlan_id='$vlan_id' WHERE id='$id'";
		$db_result = mysql_query($sql, $conf['dbh']);
	}

	$vlan   = new VLAN($id);
	$action = 'edit';
}
elseif ( $action == 'delete' && $really ) {
	// actually delete the VLAN
	$sql = "DELETE FROM vlan WHERE id=$id";
	$db_result = mysql_query($sql, $conf['dbh']);
	
	// set any workgroups using this VLAN to 0 for the vlan column
	$sql = "UPDATE workgroup SET vlan=0 WHERE vlan=$id";
	$db_result = mysql_query($sql, $conf['dbh']);

	$action = 'show_vlans';
}
elseif ( $action == 'edit' ) {
		$vlan = new VLAN($vlan_id);
}

show_template('header');

?>
<font class="header1"><?php echo $title ?></font>

<?php 

	$sql = "SELECT * FROM vlan";

	if (!$user->view) {
                $user->view = new View($sql);
        }


	if ($sort_type) {
		$user->view->initialize($sort_type,$sort_offset);
        }
        else {
		$user->view->initialize('name', $sort_offset);
        }


	if ( $action == 'edit' ) {
		// show the vlan edit form (different from create?)
		$conf['ui']->show_vlan($action, $vlan);
	}
	elseif ( $action == 'show_vlans' ) {
		// give them the option to create a new vlan
		echo "<p><a href=\"" . $conf['web_path'] . "/vlan.php?action=show_create\">Create a new VLAN.</a></p>\n";
		// show the vlan's using the view widget
		$vlans = $conf['ui']->get_vlans();
		$conf['script'] = "vlan.php";
		$total_items = mysql_num_rows(mysql_query($user->view->get_sql(), $conf['dbh']));

		$conf['ui']->show_vlans($vlans, $total_items);
	}
	elseif ( $action == 'show_create' ) {
		// show the vlan creation form
		$conf['ui']->show_vlan($action, $vlan);
	}
	elseif ( $action == 'delete' ) {
		// show the confirm delete
		$vlan = new VLAN($id);
		$conf['ui']->show_confirm("/vlan.php?action=delete&really=1&id=$id","Are you sure you want to delete this VLAN? <b>($vlan->name with VLAN ID of $vlan->vlan_id)</b>");
	}

?>

<?php show_template('footer'); ?>
