<?php

/*

 $Id: autoreg.php,v 1.17 2003/07/16 20:29:04 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/autoreg.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header AutoReg Module Class
	This class is for autoregistration. These functions could go into
	host.php but they are here so it's more modular

*/

class Autoreg {

	var $username;
	var $hosts;

	//constructor
	function Autoreg($username=0) {
		global $conf;
	
		$this->username = $username;

		if ($username) { 
			$this->hosts = $this->get_info();
			if ($this->hosts[0]->status == "disabled") { $this->disabled = TRUE; }
		} 

	} //autoreg

	//grabs up to two hosts that they are allowed to use. 
	function get_info() {
		global $conf,$user;

		$ranges = $this->find_autoreg_dynamic();

		//grab N where other_id is username and it's on the right range (dependent on autoreg_zone_name)
		$sql = "SELECT host.id,host.status FROM host WHERE host.other_id='$this->username' AND host.location !='auto_add' AND ( ";

		// go through the ranges 		
		foreach ($ranges as $range) {
			if (substr_count($sql,"dynamic_range")) { $sql .= " OR dynamic_range='$range->id'"; }
			else { $sql .= " dynamic_range='$range->id'"; }
		} // end foreach

		$sql .= " ) ";

		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
			$results[] = $r;
		}

		return $results;

	} //get_info

	/*!
		@function get_type
		@discussion Get the type of autoregistration said zone is in
	*/
	function get_type($zone_name) { 
		global $conf;

		$item = $conf['modules']->get_info("autoreg");
	
		foreach ($item['zone_name'] as $key => $name) {
			if ($zone_name == $name) {
				return $key;
			}
		}

	} // get_type

	/*!
		@function is_pub_host
		@discussion this pulls the information about the current _autoreg_ user if possible
			    from the db that kveton put togeather (pulled from dhpc logs)
			    returns an object with ip/date and mac
	*/
	function is_pub_host() {
		global $conf,$user;

		$item = $conf['modules']->get_info("autoreg");

		$ip = getenv(REMOTE_ADDR);
		$ip_obj = new IP(0);
	        $ipint = $ip_obj->ip2int($ip);

		//we need to make sure they are in the autoreg section
		if ($ipint <= $item['free_end'][$user->autoreg_type] AND $ipint >= $item['free_start'][$user->autoreg_type]) {
			//first get the mac address that the dhcp server saw
			$sql = "SELECT * FROM autoreg WHERE ip='$ipint'";
			$db_results = mysql_query($sql, $item['dbh']);
			$data = mysql_fetch_object($db_results);	
			
			$ranges = $this->find_autoreg_dynamic();

			//remove the :'s from our mac addie so we can check
			$mac_addie = $conf['ui']->clean_hardware_address($data->mac);

			/* Do some sanity checking.. make sure we have a mac here */
			if (strlen($mac_addie) == 12) {
				//now check to see if it's inside the autoreg for maintain
				$sql = "SELECT id FROM host WHERE ha='$mac_addie' AND dynamic_range='$range_id->id'";
				$db_results = mysql_query($sql, $conf['dbh']);
	
				//if we find the host then 
				if (mysql_fetch_row($db_results)) { 
					return false;
				} 
				else {
					return $data; 
				}

			} //if the mac is 12 chr's still..

					
		}

		return false;

	} //is_pub_host

	/*!
		@function get_autoreg_ranges
		@discussion gets all of the ranges assoicated with this type of autoregistration
	*/
	function get_autoreg_ranges($autoreg_type) {
		global $conf;

		$item = $conf['modules']->get_info("autoreg");

	        $start = $item['ip_start'][$autoreg_type];
	        $end   = $item['ip_end'][$autoreg_type];

		$sql = "SELECT id FROM ranges WHERE start>='$start' AND end<='$end' AND type='dynamic'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) { 
			$results[] = new Range($r);
		}

		return $results;

	} // get_autoreg_ranges

	/*!
		@function get_other_hosts
		@discussion get hosts that are not in the defined autoreg site, we assume $user->autoreg_type is the current 
			    autoreg site
		@param $autoreg_type	Current Autoreg site
		@results Returns an array of host objects
	*/
	function get_other_hosts($autoreg_type) {
		global $conf,$user;

		$item = $conf['modules']->get_info("autoreg");

		$hosts = array();
		// get the keys
		$keys = array_keys($item['title']);
		foreach ($keys as $key) {
			if ($key != $user->autoreg_type) { 
				$hosts = array_merge($hosts,$this->get_site_hosts($key)); 
			}
		}

		return $hosts;

	} // get_other_hosts

	/*!
		@function get_site_hosts
		@discussion gets all of their autoreg hosts for a specific site
		@param $autoreg_type	The site we are looking at
		@param $username	Option the specific username, otherwise uses $user->username
	*/
	function get_site_hosts($autoreg_type,$username=0) {
		global $conf,$user;
		
		if (!$username) { $username = $user->username; }

		$ranges = $this->find_autoreg_dynamic($autoreg_type);
		$sql = "SELECT name,id FROM host WHERE other_id='$username' AND ( ";

		foreach ($ranges as $range) {
			if (preg_match("/dynamic_range/",$sql)) { $sql .= " OR dynamic_range='$range->id'"; }
			else { $sql .= " dynamic_range='$range->id'"; }
		}

		$sql .= " OR location='auto_add' ) ";

		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($r = mysql_fetch_object($db_results)) {
			$host = new Host($r->id);
			preg_match("/^(.+)\-.+\-\w/",$r->name,$matches);
			$host->autoreg_type = $matches[1];
			$results[] = $host;
		}
		
		return $results;

	} // get_site_hosts

	/*!
		@function has_acl_access
		@discussion Checks to see if the user has access to the ACL'd site
		@param $username	User we are checking
		@param $autoreg_type	The Site we are checking
	*/
	function has_acl_access($username,$autoreg_type) {
		global $conf;

		$item = $conf['modules']->get_info("autoreg");

		$table = $item['acl_db_table'][$autoreg_type];

		$sql = "SELECT * FROM $table WHERE username='$username' AND type='$autoreg_type'";
		$db_results = mysql_query($sql, $item['acl_dbh'][$autoreg_type]);

		if (mysql_fetch_object($db_results)) { 
			return true;
		}
		else {
			return false;
		}

	} // has_acl_access

	/*!
		@function autoreg_widget
		@discussion widget to show if for regristering (small)
	*/
	function autoreg_widget() {
		global $conf;

		$title = "Public Network Registration";
		$width = "100%";
		
		$items[] = "<a href=\"". $conf['web_path'] . "/modules/autoreg.php\">Register your Computer(s)</a>";

		$conf['ui']->display_widget($items,$title,$width);

	} //autoreg_widget

	/*!
		@function show_zone_widget
		@discussion this is the widget it shows if you are in an autoreg zone
	*/
	function show_zone_widget() {
		global $conf;

		$items[] = "<a href=\"" . $conf['web_path'] . "/modules/autoreg.php?action=show_create_host&amp;autoreg_type=true&amp;aup=accepted\">Create a new host</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/host.php?action=show_hosts\">Show Hosts</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/range.php?action=show_zone_range_mapping\">View IP Address Usage</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/csv.php\">Email a CSV of my Zone</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_unregistered_hosts\">Show Unregistered Hosts</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_confused_hosts\">Show Incorrectly Registered Hosts</a>";

		if ($conf['modules']->modules['flo']->enabled ) {
                        //generate yesterdays date exactly.. ugg
                        $date = strtotime ("-1 day 23:59:00");
                        $items[] = "<a href=\"". $conf['web_path'] .
                                "/modules/flo.php?action=show_top_zone&amp;date=$date&amp;count=".$conf['module_flo_top_count']."&amp;zone_id=".$conf['zone']->id."\">Bandwidth Report</a>";
                } //end if flo enabled

	$conf['ui']->display_widget($items,"Autoregistration Tools",$width);

	} // show_zone_widget

	/*!
		@function show_other_hosts
		@discussion Displays the template for "Other Hosts"
		@param $hosts	Array of the other hosts...
	*/
	function show_other_hosts($hosts) {
		global $conf;

		require ($conf['prefix'] . "/templates/show_autoreg_other_hosts.inc");

	} // show_other_hosts

	/*!
		@function add_host
		@discussion adding a new autoregistration host.. this is slightly complex
		we have to get the ranges in this autoreg_type then go through and find the
		range with free address and then we can go ahead and create the host.
		@param $ha		Hardware Address of the Computer
		@param $hw_type 	Wired/Wireless
		@param $username 	The Username of the person
		@param $autoreg_type	The Autoreg site we are adding to only used if different than $user->autoreg_type
		@param $comment		Comment to go along with this creation not required
	*/
	function add_host($ha,$hw_type,$username,$autoreg_type=0,$location=0,$comment=0) {
		global $conf, $user;

		if (!$autoreg_type) { $autoreg_type = $user->autoreg_type; }
	
		//get the range we need
		$ranges = $this->find_autoreg_dynamic($autoreg_type);

		// go through and find the range with a
		// open spot
		foreach ($ranges as $range) {
			if ($range->get_free_address_count() > 0) {
				$range_id = $range->id;
				break;
			} 
		} // end foreach

		//create the crap we need to make this host
		$range = new Range($range_id);
		$domain_id = $range->default_domain->id;
		$workgroup = $range->default_workgroup;
	
		$other_id = $username;
                $fullmd5 = substr(md5($ha),0,12);
		$name = $autoreg_type . "-" . $fullmd5 . "-" . $hw_type;

		$host_id = $this->create_host($name, $domain_id, '0', $ha, $os, $hw_type, $location, $serial, $other_id, $range->id, $workgroup);

		$host = new Host($host_id);
		$host->object_history->update($user->username,$comment);

		return $host_id;

	} //add_host

	/*!
		@function find_autoreg_dynamic
		@discussion find out where we need to put this host (returns range_id)
		@results returns an array of ranges
	*/
	function find_autoreg_dynamic($autoreg_type=0) {
		global $conf,$user;

		if (!$autoreg_type) { $autoreg_type = $user->autoreg_type; }

		$item = $conf['modules']->get_info("autoreg");

		$ip_start = $item['ip_start'][$autoreg_type];
		$ip_end = $item['ip_end'][$autoreg_type];

		//find the first dynamic range for specified zone
	        $sql = "SELECT id FROM ranges WHERE start>='$ip_start' AND end<='$ip_end' AND type='dynamic'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
			$results[] = new Range($r->id);
		}

		return $results;

	} // find_autoreg_dynamic

	/*!
		@function get_zone_id
		@discussion get the zone id of the autoreg zone for this autoreg_type
	*/
	function get_zone_id($autoreg_type=0) {
		global $conf,$user;

		if (!$autoreg_type) { $autoreg_type = $user->autoreg_type; }

		$item = $conf['modules']->get_info("autoreg");

		$sql = "SELECT id FROM zone WHERE name='" . $item['zone_name'][$autoreg_type] . "'";
		$db_results = mysql_query($sql, $conf['dbh']);
	
		$r = mysql_fetch_row($db_results);

	return $r->id;

	} //get_zone_id
	
	/*!
		@function get_host
		@discussion gets the a host based on the hardware address from a specific autoreg site
		@param $ha	Hardware address of the host
		@param $autoreg_type Autoreg Site
	*/
	function get_host($ha,$autoreg_type) {
		global $conf;


		$ranges = $this->find_autoreg_dynamic($autoreg_type);		
	
		$sql = "SELECT id FROM host WHERE ha='$ha' AND ( ";

		foreach ($ranges as $range) {
			if (preg_match("/dynamic_range/",$sql)) { $sql .= " OR dynamic_range='$range->id'"; }
			else { $sql .= " dynamic_range='$range->id'"; }
		} // end foreach

		$sql .= " ) ";

		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);
		$host = new Host($results->id);

		return $host;

	} // get_host

	/*!
		@function update_host
		@discussion function to update an autoreg host...
	*/
	function update_host($host_id,$ha,$type,$username,$autoreg_type=0,$location=0) {
		global $conf, $user;

		if (!$autoreg_type) { $autoreg_type = $user->autoreg_type; }

                $other_id = $username;
                $fullmd5 = substr(md5($ha),0,12);
                $name = $autoreg_type . "-" . $fullmd5 . "-" . $type;
		$uname = $user->username;

		$sql = "UPDATE host SET ha='$ha', name='$name', type='$type', other_id='$username', location='$location' WHERE id='$host_id'";

		$host = new Host($host_id);

		$db_results = mysql_query($sql, $conf['dbh']);

		$host->object_history->update($user->username);

	} // update_host

        /*!
		@function create_host
		@discussion actually does the sql call to create a host
	*/
        function create_host ($name, $domain_id, $ip_id, $ha, $os, $type, $location, $serial, $other_id, $range_id, $workgroup_id) {
                global $conf,$user;

		$item = $conf['modules']->get_info("autoreg");

		$sql = "SELECT * FROM zone WHERE name='" . $item['zone_name'][$user->autoreg_type] . "'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$zone = mysql_fetch_object($db_results);

                $sql = "INSERT INTO host (name,domain,ip,dynamic_range,ha,os,type,location,serial,other_id,workgroup,zone)
                                VALUES ('$name', '$domain_id', '$ip_id', '$range_id', '$ha', '$os', '$type', '$location',
                                '$serial', '$other_id', '$workgroup_id', '$zone->id')";

                $db_result = mysql_query($sql, $conf['dbh']);
                $host_id   = mysql_insert_id($conf['dbh']);

                return $host_id;
        } // create_host


} // class Autoreg

?>
