<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: subnet.php,v 1.15 2003/06/30 18:03:41 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/subnet.php,v $

 The subnet class definition for doing work with subnets.

*/

class Subnet {
	var $id;
	var $name;
	var $subnet;
	var $subnet_addr;
	var $netmask;
	var $netmask_addr;
	var $router;
	var $router_addr;
	var $status;
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Subnet ( $subnet_id ) {
		global $conf;

		$this->id = $subnet_id;

		$info = $this->get_info();

		// set all of the objects attributes
		$this->name	    = $info->name;

		$this->subnet	    = new IP(0);
		$this->subnet->update_ip_int($info->subnet);

		$this->netmask	    = new IP(0);
		$this->netmask->update_ip_int($info->netmask);

		$this->router      = new IP(0);
		$this->router->update_ip_int($info->router);

		$this->status	    = $info->status;

		//Things gathered from object_history
		$this->object_history = new ObjectHistory('subnet', $this->id);

	} // Subnet 

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM subnet WHERE id='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_results);
	} // get_info

	// The PHP functions for this just fail ... and I'm not sure why.
	//   Adam Gretzinger built these functions that work just fine for
	//   our needs.  These can be used generically as well as with the
	//   IP class.
	function int2ip($i) {
		$d[0]=(int)($i/256/256/256);
		$d[1]=(int)(($i-$d[0]*256*256*256)/256/256);
		$d[2]=(int)(($i-$d[0]*256*256*256-$d[1]*256*256)/256);
		$d[3]=$i-$d[0]*256*256*256-$d[1]*256*256-$d[2]*256;
		return "$d[0].$d[1].$d[2].$d[3]";
	} // int2ip

	// Take an IP and turn it into an INT.
	function ip2int($ip) {
		$a=explode(".",$ip);
		return $a[0]*256*256*256+$a[1]*256*256+$a[2]*256+$a[3];
	} // ip2int

	// return a VLAN object for this subnet
	function get_vlan () {
		// notice that the vlan object is different than most
		//   classes in that its constructor isn't made with _its_
		//   id from the database ... it uses the subnet id
		return new VLAN($this->id);
	}

	//Get the Last IP in the subnet takes subnet_int and netmask_int
	function get_end($subnet_int,$netmask_int) {
		global $conf;

		$ip = new IP(0);

		//The max subnet value
	        $max  = $ip->ip2int('255.255.255.255');
	        $diff = $max - $netmask_int;
	
	        $subnet_end = $subnet_int + $diff;

		return $subnet_end;

	} //get_end

	/*!
		@function get_options
		@discussion get the local options for this object assumes $this
	*/
	function get_options() {
		global $conf;

		$sql = "SELECT * FROM subnet_option_local WHERE subnet=$this->id";
		$db_result = mysql_query($sql, $conf['dbh']);

		while ( $obj = mysql_fetch_object($db_result) ) {
                        $options[] = new Option($obj->id, "subnet");
                }

		return $options;

	} // get_options

	//Check for overlap of Subnets, returns subnet_id if overlap found
	function check_overlap($subnet_int,$subnet_end) {
		global $conf;

		//First check and see if there is a subnet the overlaps after this one
		$sql = "SELECT * FROM subnet WHERE subnet > $subnet_int AND subnet <= $subnet_end";
		$db_results = mysql_query($sql, $conf['dbh']);

		if ($r = mysql_fetch_object($db_results)) {
			return $r->id;
		}

		//Now check to see if the previous subnet overlaps
		$sql = "SELECT * FROM subnet WHERE subnet < $subnet_int ORDER BY subnet DESC LIMIT 1";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);
		$netmask_int = $results->netmask;
		$subnet_int = $results->subnet;

		$this->get_end($subnet_int,$netmask_int);

		// If the end it bigger than the start of our subnet they must be overlaping
		if ($results_end >= $subnet_int) {
			return $results->id;
		}

		return false;


	} //check_overlap

	/* All the update functions below! */
	function update_name($new_name) {
		
		$this->update_item('name',$new_name);
		$this->name = $new_name;

	}

	function update_subnet($new_subnet) {
		
		$this->update_item('subnet',$new_subnet);
		$this->subnet = $this->subnet->update_ip_int($new_subnet);
	
	}

	function update_netmask($new_netmask) {
		
		$this->update_item('netmask', $new_netmask);
		$this->netmask = $this->netmask->update_ip_int($new_netmask);
	
	}

	function update_router($new_router) {
		
		$this->update_item('router', $new_router);
		$this->router = $this->router->update_ip_int($new_router);

	}

	function update_status($new_status) {
		
		$this->update_item('status', $new_status);
		$this->status = $new_status;

	}

	//Generic updating function used by other functions here
        function update_item ($type, $new_item) {
                global $conf;

                $sql = "UPDATE subnet SET $type='$new_item' WHERE id='$this->id'";
                $db_result = mysql_query($sql, $conf['dbh']);

        } //update_item


	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print("Subnet: name -> $this->name, subnet -> $this->subnet, ".
			"netmask -> $this->netmask, status -> $this->status ".
			"end Subnet<br>\n");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
} // class Subnet

?>
